/*********************************************************************
 *
 *                  BMS UI ADC File
 *
 *********************************************************************
 * FileName:        BMS_UI_ADC.c
 * Processor:       PIC18F25K80
 * Compiler:        Microchip C18 v3.41
 * Company:         KIT - CN - IPE
 *
 * Author           Date         Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Ott W.           08.02.2016   Release
 *********************************************************************/

/*********************************************************************
 *
 *                          Include Files
 *
 ********************************************************************/
#include "BMS_UI_Main.h"



/*+++++++ ADCread BMS_UI +++++++++++++++++++++++++++++++++++++++++++*/
uint16_t ADCread_12Bit( )
{
  uint8_t  HBB, MBB;
  uint16_t RxBuffer = 0;
  uint8_t i = 0;
  uint8_t k = 0;

  LATAbits.LATA5 = 0;                // CS HV SPI ON

  for(i = 0; i < 40; i++)
  {
      k++;
  }

  k = 0;
  
  SSPBUF = 0;	                       // Send Byte
  while(!PIR1bits.SSPIF);	       // wait until Send complete
    PIR1bits.SSPIF = 0;	               // clear SSPIF Bit
  HBB = SSPBUF;                        // store High Byte to Buffer
  
  SSPBUF = 0;                          // Send Byte
  while(!PIR1bits.SSPIF);	       // wait until Send complete
  PIR1bits.SSPIF = 0;	               // clear SSPIF Bit
  MBB = SSPBUF;                        // store Mid Byte to Buffer
  

  RxBuffer = (HBB & 0x3F);             // Build 12 Bit ADC Result
  RxBuffer = RxBuffer << 8;
  RxBuffer = RxBuffer + MBB;
  RxBuffer = RxBuffer >> 1;

  LATAbits.LATA5 = 1;                  // CS HV SPI OFF

  return RxBuffer;
}

/*+++++++ ADCread BMS_UI +++++++++++++++++++++++++++++++++++++++++++*/
uint16_t ADCread_16Bit( )
{
  uint8_t  HBB, MBB, LBB;
  uint16_t RxBuffer = 0;
  uint8_t i = 0;
  uint8_t k = 0;

  LATCbits.LATC0 = 0;                // CS HI SPI ON

  for(i = 0; i < 20; i++)
  {
      k++;
  }

  k = 0;

  SSPBUF = 0;	                       // Send Byte
  while(!PIR1bits.SSPIF);	       // wait until Send complete
    PIR1bits.SSPIF = 0;	               // clear SSPIF Bit
  HBB = SSPBUF;                        // store High Byte to Buffer

  SSPBUF = 0;                          // Send Byte
  while(!PIR1bits.SSPIF);	       // wait until Send complete
  PIR1bits.SSPIF = 0;	               // clear SSPIF Bit
  MBB = SSPBUF;                        // store Mid Byte to Buffer

  SSPBUF = 0;                          // Send Byte
  while(!PIR1bits.SSPIF);	       // wait until Send complete
  PIR1bits.SSPIF = 0;	               // clear SSPIF Bit
  LBB = SSPBUF;                        // store Low Byte to Buffer


 RxBuffer = HBB;                      // Build 16 Bit ADC Result
 RxBuffer = RxBuffer << 8;
 RxBuffer = RxBuffer + MBB;
 RxBuffer = RxBuffer << 6;
 RxBuffer = RxBuffer + (LBB >> 2);

 LATCbits.LATC0 = 1;                  // CS HI SPI OFF

 return RxBuffer;
}

int16_t ADC_supply_voltage(uint8_t ADC_CH )
{
    int16_t analog_reading = 0;

    ADCON0bits.CHS = ADC_CH;             // Set adc channel to read
    ADCON0bits.GO = 1;                   //Start A/D Conversion

    while(ADCON0bits.GO == 1)
    {
        //Loop here until A/D conversion completes
    };

    analog_reading= ( (((uint16_t)ADRESH << 8)+ADRESL));        // readout ADC

    return analog_reading;

}
