/*********************************************************************
 *
 *                  BMS_UI_Measure Header
 *
 *********************************************************************
 * FileName:        BMS_UI_Measure.h
 * Processor:       PIC18F25K80
 * Compiler:        Microchip C18 v3.41
 * Company:         KIT - CN - IPE
 *
 * Author           Date         Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Ott W.           08.02.2016   Release
 *********************************************************************/

#ifndef BMS_UI_MEASURE_H      // To avoid duplicate inclusion
#define BMS_UI_MEASURE_H


/*********************************************************************
*
*                             Defines
*
*********************************************************************/
#define LEM_OK            1
#define LEM_NOK           0

#define Takt              10  //5, 10 oder 20 Hz

#if Takt==5
  #define MS_Count        20
  #define OverSample      2560
  #define FirstShift      9
#endif

#if Takt==10
  #define MS_Count        10
  #define OverSample      64
  #define FirstShift      8
#endif

#if Takt==20
  #define MS_Count        5
  #define OverSample      640
  #define FirstShift      7
#endif

  #define UMulpli         1751
  #define IMulpli         819
  #define ULastShift      16
  #define ILastShift      11
  #define IOffset         80000

/*********************************************************************
 *
 * external Globals
 *
 ********************************************************************/

extern uint16_t gTimer;
extern int16_t  gOffsetCurrent;
extern uint16_t  gOffsetVoltage;

/*********************************************************************
*
*                        Function Prototypes
*
*********************************************************************/
uint16_t Measure( void );
extern uint16_t ADCread_12Bit( );
extern uint16_t ADCread_16Bit( );

#endif
